import QtQuick 1.1
import com.nokia.meego 1.1
import "Storage.js" as Storage

Page {
    tools: infopageTools
    orientationLock: PageOrientation.LockPortrait
    Component.onCompleted: {
    theme.inverted = true
    }


    Rectangle {
    id: infopage
    width: parent.width
    height: parent.height
    color: !theme.inverted ? "White" : "Black"

    Flickable {
        id: infoflickable
        width: parent.width - 20
        height: parent.height - 40
        anchors.horizontalCenter: parent.horizontalCenter
        clip: true
        anchors.centerIn: parent
        contentHeight: 2000
        contentWidth: parent.width - 40
        flickableDirection: Flickable.VerticalFlick

        Column {
            id: infocolumn
            spacing: 15
            width: parent.width
            height: 1800

            Row {
                spacing: 20
                width: parent.width
                anchors.horizontalCenter: parent.horizontalCenter
                height: childrenRect.height
                Image {
                    source: "GPSLogMee80.png"
                }
                Column {
                    spacing: 5
                    width: 300
                    Label {
                        text: "GPS LogMee"
                        font.pixelSize: 30
                    }
                    Label {
                        text: "GPS Logger for N9/N950"
                        font.pixelSize: 18
                    }
                }
            }
            Label {
                text: "A simple application that lets you log your journey with options to review older logs on the phone or Nokia Maps Online."
                wrapMode: Text.WordWrap
                maximumLineCount: 3
                width: parent.width
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: 22
                font.capitalization: Font.SmallCaps
            }

            Label {
                height: 40
                text: "About GPS LogMee"
                wrapMode: Text.WordWrap
                maximumLineCount: 1
                width: parent.width
                anchors.horizontalCenter: parent.horizontalCenter
                verticalAlignment: Text.AlignBottom
                font.pixelSize: 30
                font.capitalization: Font.SmallCaps
            }

            Text {
                text: "Version 1.1.0:"
                width: infoflickable.width
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 18
                color: !theme.inverted ? "black" : "white"
            }
            Text {
                text: " Added Automatic Pause Option. Added saving altitude and timestamp from source.\n" +
                      " Added local option for saving a gpx text file on the phone. \n" +
                      " Added Option to copy track link to clipboard.\n"
                width: infoflickable.width
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 18
                color: !theme.inverted ? "black" : "white"
                font.capitalization: Font.SmallCaps
                //color: "white"
                maximumLineCount: 4
            }

            Text {
                text: "Application Functions."
                font.capitalization: Font.SmallCaps
                font.bold: true
                width: infoflickable.width
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
            }
            Row {
                spacing: 20
                Image {
                    source: "image://theme/icon-m-toolbar-settings-white"
                }
                Text {
                    text: "Click on Settings Icon to change your application settings, you can also delete all Logs."
                    width: infoflickable.width - 20
                    wrapMode: Text.WordWrap
                    smooth: true
                    font.pixelSize: 22
                    color: !theme.inverted ? "black" : "white"
                }
            }
            Row {
                spacing: 20
                Image {
                    source: "image://theme/icon-m-toolbar-list-white"
                }
                Text {
                    text: "Click on this Icon to open this information page."
                    width: infoflickable.width - 20
                    wrapMode: Text.WordWrap
                    smooth: true
                    font.pixelSize: 22
                    color: !theme.inverted ? "black" : "white"
                }
            }
            Text {
                text: "Start a new GPS Log"
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                font.bold: true
            }
            Text {
                text: "Select this button to start collecting a new GPS Log, this will allow you to save your Latitude, Longitude and distance."
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
            }
            Text {
                text: "View Old Logs"
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                font.bold: true
            }
            Text {
                text: "If you have used the application and saved logs, this will allow you to review old data. " +
                "You can delete old logs from the application settings page."
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"

            }
            Text {
                text: "Your Privacy, Location Data/ Location Services."
                width: infoflickable.width - 40
                font.capitalization: Font.SmallCaps
                font.bold: true
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
            }
            Text {
                text: "This Application allows you to find your GPS location and this information is displayed on the phone. \n\n This detailed information is not shared by default; however you can choose to make Logs of your GPS positions to your phone. The Logs are not shared with any other third parties, however you can upload your Logs to our servers for viewing online with Nokia Maps. \n\n There are no tracking technologies used in this application, it does not phone home or register your application use. As you start the application it looks for an internet connection to display the first Nokia Map with the coordinates of 0,0. After a GPS Position is found, the application will use the connection again to display an updated Nokia Map of your location. \n\n This application uses Nokia & Nokia Maps services/APIs, relative privacy policies also apply. No personal identity data is collected by this application. For any questions, please contact nokia@dv8.com.au."
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                font.capitalization: Font.SmallCaps
            }
            Text {
                text: "Check out http://www.preesworld.com/mobile or follow <a href = \"http://twitter.com/mjjagpal\"><font color=\"#4c90c6\">@mjjagpal</font></a> for more."
                width: infoflickable.width - 40
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
            }
        }
    }
    }

    ToolBarLayout {
        id: infopageTools
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: appWindow.pageStack.pop()
        }
    }
}
