import QtQuick 1.1
import com.nokia.meego 1.1

import "Storage.js" as Storage

Page {
    tools: saverLogsTools
    orientationLock: PageOrientation.LockPortrait

    property int logNumberU: 0
    property string copythis: ""
    property string saveFileName: ""
    property int thistripSU: 0

    onStatusChanged: {
        if (status == PageStatus.Activating ) {
            Storage.logstosave(logNumberU)
            //copybutton.visible = false
            thistripSU = Storage.detailedogstoviewS(logNumberU)
            saveFileName = "GPSLogMee_Log_" + logNumberU + "_" +(parseInt(thistripSU) + 1)+ ".txt"
            if(thistripSU >= 800) {savertimer.interval = 2000;}
            else {savertimer.interval = 1000;}
        }
    }

    Timer {
        id: savertimer
        running: false
        repeat: false
        interval: 1000
        onTriggered: {
            indicatorSave.running = false
            indicatorSave.visible = false
        }
    }

    BusyIndicator {
        id: indicatorSave
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        anchors.topMargin: 300
        platformStyle: BusyIndicatorStyle { size: "large" }
        running:  false
        visible: false

    }

    Column {
        anchors.top: parent.top
        anchors.topMargin: 20
        width: parent.width
        height: childrenRect.height
        spacing: 20

        Row {
            spacing: 20
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            height: childrenRect.height
            Image {
                source: "GPSLogMee80.png"
                //opacity: 0.3
            }
            Column {
                spacing: 5
                width: 300
                Label {
                    text: "GPS LogMee"
                    font.pixelSize: 30
                    //opacity: 0.3
                }
                Label {
                    text: "GPS Logger for N9/N950"
                    font.pixelSize: 18
                    //opacity: 0.3
                }
            }

        }

        Label {
            height: paintedHeight
            text: "GPS Logger Text File Saver."
            wrapMode: Text.WordWrap
            maximumLineCount: 1
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: "Using this option will save a text file to your " +
            "device, in the Documents folder."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: "File will be saved as:"
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: saveFileName
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 28
            font.capitalization: Font.SmallCaps
            color: "white"
        }


        Button {
            id: savebutton
            anchors.horizontalCenter: parent.horizontalCenter
            text: "Save Now"
            width: parent.width - 2 * platformStyle.paddingLarge
            height: 50
            onClicked: {
                savertimer.start()
                indicatorSave.running = true
                indicatorSave.visible = true
                //onlineresponsetext.text = "Uploading"
                //sendCoords()
                savebutton.enabled = false
                //saveresponsetext.text = saved
                QMLFile.saveFileContents(coords1, saveFileName);
            }
        }
        Label {
            id: saveresponsetext
            height: paintedHeight
            text: ""
            wrapMode: Text.WordWrap
            maximumLineCount: 4
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }


    }

    ToolBarLayout {
        id: saverLogsTools
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop()
        }
    }

}
