import QtQuick 1.1
import com.nokia.meego 1.1

import "Storage.js" as Storage

Page {
    tools: uploadLogsTools
    orientationLock: PageOrientation.LockPortrait

    property int logNumberO: 0
    property string copythis: ""

    function sendCoords() {
        //Storage.onlinelogstoview()
        var coordsURL = "http://www.preesworld.com/nokiamaps/index.php"
        var postman = new XMLHttpRequest()
        var postData = "set2=" + coords2 + "&set1=" + coords1 + "&set3=" + data1 + "&set4=" + data2 + "&set5=" + data3
        //console.log(postData)
        postman.open("POST", coordsURL, true);
        postman.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        postman.onreadystatechange = function() {
            if (postman.readyState == postman.DONE) {
                //console.log("Your Coords has been uploaded.");
                var ab = postman.responseText;
                //console.log("response text: ",ab)
                onlineresponsetext.text = "Your Map is now available on: \n \n"+
                        "http://www.preesworld.com/ \n" +
                        "nokiamaps/" + ab;
                copythis = "http://www.preesworld.com/nokiamaps/" + ab;
                indicatorUpload.running = false
                indicatorUpload.visible = false
                uploadbutton.enabled = true
                copybutton.visible = true
            }
            }
        postman.send(postData);
        console.log(postData)
    }

    onStatusChanged: {
        if (status == PageStatus.Activating ) {
            Storage.onlinelogstoview(logNumberO)
            //copybutton.visible = false
        }
    }

    BusyIndicator {
        id: indicatorUpload
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        anchors.topMargin: 300
        platformStyle: BusyIndicatorStyle { size: "large" }
        running:  false
        visible: false

    }

    Column {
        anchors.top: parent.top
        anchors.topMargin: 20
        width: parent.width
        height: childrenRect.height
        spacing: 15

        Row {
            spacing: 20
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            height: childrenRect.height
            Image {
                source: "GPSLogMee80.png"
                //opacity: 0.3
            }
            Column {
                spacing: 5
                width: 300
                Label {
                    text: "GPS LogMee"
                    font.pixelSize: 30
                    //opacity: 0.3
                }
                Label {
                    text: "GPS Logger for N9/N950"
                    font.pixelSize: 18
                    //opacity: 0.3
                }
            }

        }

        Label {
            height: paintedHeight
            text: "GPS Logger Web Uploader."
            wrapMode: Text.WordWrap
            maximumLineCount: 1
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: "Using this service will upload your log to web servers " +
            "at dv8.com.au. Mapped by Nokia Maps."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: "Please make sure you read and agree with the Privacy statement in About."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }
        Label {
            height: paintedHeight
            text: "Currently there are no limits on the amount of logs uploaded, however they may be deleted at some time."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }

        Button {
            id: uploadbutton
            anchors.horizontalCenter: parent.horizontalCenter
            text: "Upload Now"
            width: parent.width - 2 * platformStyle.paddingLarge
            height: 50
            onClicked: {
                indicatorUpload.running = true
                indicatorUpload.visible = true
                onlineresponsetext.text = "Uploading"
                sendCoords()
                uploadbutton.enabled = false
            }
        }
        Label {
            id: onlineresponsetext
            height: paintedHeight
            text: ""
            wrapMode: Text.WordWrap
            maximumLineCount: 4
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }

        Button {
            visible: false
            id: copybutton
            anchors.horizontalCenter: parent.horizontalCenter
            text: "Copy Link"
            width: parent.width - 2 * platformStyle.paddingLarge
            height: 50
            onClicked: Clippy.setText(copythis)
        }

    }

    ToolBarLayout {
        id: uploadLogsTools
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop()
        }
    }

}
