import QtQuick 1.1
import com.nokia.meego 1.1
import QtMobility.location 1.2

import "Storage.js" as Storage

Page {
    tools: startTools
    orientationLock: PageOrientation.LockPortrait

    Coordinate{ id: newLocationFS }
    property int modelSMapPage: 0

    //Make new live track
    function newLiveTrack() {
        //livetrackmodel.clear()
         var temptracksmodel = null;
        temptracksmodel = Storage.livetrackingCoOrd(0);
        for (var i = 0; i < temptracksmodel.length; i ++) {
            //livetrackmodel.append(temptracksmodel[i])
            newLocationFS.latitude = temptracksmodel[i].lvtklat
            newLocationFS.longitude = temptracksmodel[i].lvtklon
            livetrackpolylineFS.addCoordinate(newLocationFS)
            console.log("From DB: ",i,"=>",temptracksmodel[i].lvtklat, temptracksmodel[i].lvtklon)
        }
        modelSMapPage = temptracksmodel.length - 1
        mapLoggingPage.center.latitude = temptracksmodel[modelSMapPage].lvtklat
        mapLoggingPage.center.longitude = temptracksmodel[modelSMapPage].lvtklon
    }

    Component.onCompleted: {
        theme.inverted = true
    }
    onStatusChanged: {
        if (status == PageStatus.Activating) {
            newLiveTrack()
        }
        if (status == PageStatus.Active) {
            mapLoggingPage.zoomLevel++
        }
        if (status == PageStatus.Deactivating) {
        }
    }

    // Map Holder
    // Map Element does not seem to follow Anchors.HorizontalCenter?
    Rectangle {
        z: 10
        anchors.top: parent.top
        anchors.topMargin: 10
        width: 350
        anchors.left: parent.left
        anchors.leftMargin: 10
        radius: 10
        color: "black"
        opacity: 0.7
        height: 100
        Row {
            spacing: 20
            width: 300
            height: childrenRect.height
            anchors.centerIn: parent
            Image {
                source: "GPSLogMee80.png"
            }
            Column {
                spacing: 5
                width: 220
                Label {
                    text: "GPS LogMee"
                    font.pixelSize: 30
                }
                Label {
                    text: "GPS Logger for N9/N950"
                    font.pixelSize: 18
                }
            }

        }
    }

    Rectangle {
        //radius: 10
        anchors.top: parent.top
        anchors.topMargin: 0
        height: parent.height
        width: parent.width
        //smooth: true
        color: "#333333"
        //border.color: "#404040"
        //border.width: 1
        anchors.horizontalCenter: parent.horizontalCenter
        clip: true
    }

        //GPS Map Element
        Map {
            z: 5
            anchors.left: parent.left
            anchors.leftMargin: 0
            anchors.top: parent.top
            anchors.topMargin: 0
            id: mapLoggingPage
            plugin : Plugin {
                name : "nokia";
                PluginParameter {
                    name: "mapping.cache.size";
                    value: 80000000
                   }
                PluginParameter {
                    name: "app_id";
                    value: "botE2TQLVokFnpBSBJ2D"
                   }
                PluginParameter {
                    name: "token";
                    value: "MF2mq6-6dqaIOwnljRTprA"
                }
            }
            connectivityMode : Map.HybridMode
            height: parent.height
            width: parent.width
            size.width: parent.width
            size.height: parent.height
            zoomLevel: 18
            center: Coordinate {
                          latitude: -33.8209808 //(myPosition.position.latitudeValid == true) ? myPosition.position.coordinate.latitude : 0 //endpointLat currentlat //
                          longitude: 150.9315149 //(myPosition.position.longitudeValid == true) ? myPosition.position.coordinate.longitude : 0 //endpointLon currentlon //
                      }
            mapType: Map.StreetMap
            MapPolyline {
                z: 20
                id: livetrackpolylineFS
                border {color: "red"; width: 5}
            }
            //MapCircle {
                //z: 20
                //center: Coordinate {
                              //latitude: -33.8209808 //(myPosition.position.latitudeValid == true) ? myPosition.position.coordinate.latitude : 0 //endpointLat currentlat //
                              //longitude: 150.9315149 //(myPosition.position.longitudeValid == true) ? myPosition.position.coordinate.longitude : 0 //endpointLon currentlon //
                          //}
                //radius: 100
                //color: "yellow"
            //}

        }
        PinchArea {
            id: pincharea
            //! Holds previous zoom level value
            property double __oldZoom
            anchors.fill: parent
            //! Calculate zoom level
            function calcZoomDelta(zoom, percent) {
                return zoom + Math.log(percent)/Math.log(2)
            }
            //! Save previous zoom level when pinch gesture started
            onPinchStarted: {
                __oldZoom = mapLoggingPage.zoomLevel
            }
            //! Update map's zoom level when pinch is updating
            onPinchUpdated: {
                mapLoggingPage.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
            }
            //! Update map's zoom level when pinch is finished
            onPinchFinished: {
                mapLoggingPage.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
            }
        }
        MouseArea {
            id: mousearea

            //! Property used to indicate if panning the map
            property bool __isPanning: false

            //! Last pressed X and Y position
            property int __lastX: -1
            property int __lastY: -1

            anchors.fill : parent

            //! When pressed, indicate that panning has been started and update saved X and Y values
            onPressed: {
                //flickableLogging.interactive = false
                __isPanning = true
                __lastX = mouse.x
                __lastY = mouse.y
            }

            //! When released, indicate that panning has finished
            onReleased: {
                __isPanning = false
                //newLiveTrack()
                //flickableLogging.interactive = true
            }

            //! Move the map when panning
            onPositionChanged: {
                if (__isPanning) {
                    var dx = mouse.x - __lastX
                    var dy = mouse.y - __lastY
                    mapLoggingPage.pan(-dx, -dy)
                    __lastX = mouse.x
                    __lastY = mouse.y
                }
            }

            //! When canceled, indicate that panning has finished
            onCanceled: {
                __isPanning = false;
            }

            //! Zoom one level when double clicked
            onDoubleClicked: {
                mapLoggingPage.center = mapLoggingPage.toCoordinate(Qt.point(__lastX,__lastY))
                mapLoggingPage.zoomLevel += 1
            }

        }

    ToolBarLayout {
        id: startTools
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: {
                bounceback = true
                pageStack.pop()
                var tracklen2 = livetrackpolylineFS.path.length
                if (tracklen2 > 0) {
                    console.log("internal path lenght?",tracklen2,livetrackpolylineFS.path.length)
                    for (var index = 0; index < tracklen2 -1; index++) {
                        livetrackpolylineFS.removeCoordinate(livetrackpolylineFS.path[0])
                    }
                }
            }
        }
    }
}
