import QtQuick 1.1
import com.nokia.meego 1.1

import "Storage.js" as Storage

Page {
    tools: oldLogsTools
    orientationLock: PageOrientation.LockPortrait

    property int clickedAlready: 0


    onStatusChanged: {
        if (status == PageStatus.Activating ) {
            clickedAlready = 0
            indicator3.visible = false
            indicator3.running = false
            oldlogsmodel.clear()
            var tempoldlogsmodel = Storage.oldlogstoview();
            for (var i = 0; i < tempoldlogsmodel.length; i ++) {
                oldlogsmodel.append(tempoldlogsmodel[i])
            }
        }
    }


    ListModel {
        id: oldlogsmodel
    }

    //Delegate for old Logs
    Component {
        id: oldlogsDelegate
        Rectangle  {
            height: 45
            width: parent.width
            color: "transparent"
            Row {
                clip: true
                spacing: 10
                anchors.verticalCenter: parent.verticalCenter
                Label {
                    text: logstarttime
                    font.bold: true
                    width: 115
                }
                Label {
                    width: 145
                    text: logruntime>= 60 ? Math.floor(logruntime/60) + " Minutes" : logruntime + " Seconds"
                }
                Label {
                    color: "grey"
                    text: logtotaldistance >= 1000 ?  Math.floor(logtotaldistance/1000) + " KMs" : Math.floor(logtotaldistance) + " Metres"
                }
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(clickedAlready == 0 ) {
                        indicator3.visible = true
                        indicator3.running = true
                        clickedAlready = 1;
                        pageStack.push(Qt.resolvedUrl("LogViewDetailsPage.qml"), {lognumberV: lognumber, logruntimeV: logruntime})
                    }
                }
            }
        }
    }
    //Section Delegate
    Component {
        id: sectionHeader
        //Rectangle {
            //id: sectionHeading
            //height: 40
            //width: parent.width
            //color: "transparent" //"#111111"
            Label {
                id: headingText
                anchors.horizontalCenter: parent.horizontalCenter
                //anchors.verticalCenter: parent.verticalCenter
                text: "Logs collected on " + section
                height: 40
                width: parent.width
                verticalAlignment: Text.AlignVCenter
                color: "lightgrey"
                font.capitalization: Font.SmallCaps
                font.pixelSize: 26
            }
        //}
    }

    BusyIndicator {
        id: indicator3
        anchors.centerIn: parent
        platformStyle: BusyIndicatorStyle { size: "large" }
        running:  false
        visible: false
    }



    Column {
        anchors.top: parent.top
        anchors.topMargin: 20
        width: parent.width
        height: childrenRect.height
        spacing: 15

        Row {
            spacing: 20
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            height: childrenRect.height
            Image {
                source: "GPSLogMee80.png"
                //opacity: 0.3
            }
            Column {
                spacing: 5
                width: 300
                Label {
                    text: "GPS LogMee"
                    font.pixelSize: 30
                    //opacity: 0.3
                }
                Label {
                    text: "GPS Logger for N9/N950"
                    font.pixelSize: 18
                    //opacity: 0.3
                }
            }

        }

        Label {
            height: paintedHeight
            text: "Please see a list below of GPS logs saved on the phone."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }

        ListView {
            width: parent.width - 40
            clip: true
            id: logsview
            height: 545
            anchors.horizontalCenter: parent.horizontalCenter
            model: oldlogsmodel
            delegate: oldlogsDelegate
            section.property: "logstartdate"
            section.criteria: ViewSection.FullString
            section.delegate: sectionHeader
        }
    }

    ToolBarLayout {
        id: oldLogsTools
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop()
        }
    }

}
