import QtQuick 1.1
import com.nokia.meego 1.1
//import QtMobility.systeminfo 1.1


import "Storage.js" as Storage

Page {
    tools: startTools
    orientationLock: PageOrientation.LockPortrait

    Component.onCompleted: {
        theme.inverted = true
    }

    onStatusChanged: {
        if (status == PageStatus.Activating) {
        }

        //if (status == PageStatus.Active) {
        //    myPosition.active = true
        //}
        if (status === PageStatus.Deactivating) {
            Storage.freqUpdateChange(freqSlider.value)
            if(switchGPSUse.checked == true) {
                Storage.gpsUseChange(true)
                useGPSOK = true
            }
            else {
                Storage.gpsUseChange(false)
                useGPSOK = false
            }
            updatetimer = freqSlider.value
            /*if(switchScreenSaver.checked == true) {
                //Storage.gpsUseChange(true)
                disableScreenSaver = true
                screenSaver.setScreenSaverDelayed(true)

            }
            else {
                //Storage.gpsUseChange(false)
                disableScreenSaver = false
                screenSaver.setScreenSaverDelayed(false)

            }*/
            //screenSaver.setScreenSaverInhibit(disableScreenSaver)
            if(switchPause.checked == true) {
                Storage.pauseChange(true)
                pauseOK = true
            }
            else {
                Storage.pauseChange(false)
                pauseOK = false
            }
        }
    }

    //ScreenSaver {
    //    id: screenSaver
    //        //Component.onCompleted: {screenSaver.setScreenSaverDelayed(true) }
    //}

    Column {
        anchors.top: parent.top
        anchors.topMargin: 20
        width: parent.width - 20
        spacing: 15
        id: infoflickable

        Row {
            spacing: 20
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            height: childrenRect.height
            Image {
                source: "GPSLogMee80.png"
            }
            Column {
                spacing: 5
                width: 300
                Label {
                    text: "GPS LogMee"
                    font.pixelSize: 30
                }
                Label {
                    text: "GPS Logger for N9/N950"
                    font.pixelSize: 18
                }
            }

        }

        Label {
            text: "A simple application that lets you log your journey with options to review older logs on the phone or Nokia Maps Online."
            wrapMode: Text.WordWrap
            maximumLineCount: 3
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 22
            font.capitalization: Font.SmallCaps
        }

        Label {
            height: 40
            text: "Application Settings:"
            wrapMode: Text.WordWrap
            maximumLineCount: 1
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            verticalAlignment: Text.AlignBottom
            font.pixelSize: 30
            font.capitalization: Font.SmallCaps
        }

        //Row {
            //width: parent.width - 20
            //anchors.horizontalCenter: parent.horizontalCenter
            //spacing: 5
            //height: 65
            Column {
                spacing: 5
                //width: 205
                width: parent.width - 20
                //height: 65
                height: childrenRect.height
                //anchors.verticalCenter: parent.verticalCenter
                anchors.horizontalCenter: parent.horizontalCenter
                Row {
                    width: parent.width //- 20
                    anchors.horizontalCenter: parent.horizontalCenter
                    spacing: 5
                    height: 55
                    Label {
                        text: "Updates in Seconds"
                        width: 205
                        wrapMode: Text.WordWrap
                        smooth: true
                        font.pixelSize: 22
                        color: !theme.inverted ? "black" : "white"
                        height: parent.height
                        //anchors.verticalCenter: parent.verticalCenter
                        verticalAlignment: Text.AlignVCenter
                    }
                    Label {
                        text: "Every " + freqSlider.value + " Seconds"
                        width: 260
                        wrapMode: Text.WordWrap
                        smooth: true
                        font.pixelSize: 18
                        font.capitalization: Font.SmallCaps
                        verticalAlignment: Text.AlignVCenter
                        height: parent.height
                        color: "grey" //!theme.inverted ? "black" : "white"
                        //height: 20
                        //anchors.verticalCenter: parent.verticalCenter
                    }
                }
                /*Label {
                    text: "Updates in Seconds"
                    width: 205
                    wrapMode: Text.WordWrap
                    smooth: true
                    font.pixelSize: 22
                    color: !theme.inverted ? "black" : "white"
                    height: parent.height
                    //anchors.verticalCenter: parent.verticalCenter
                    verticalAlignment: Text.AlignVCenter
                }
                Label {
                    text: "Every " + freqSlider.value + " Seconds"
                    width: 205
                    wrapMode: Text.WordWrap
                    smooth: true
                    font.pixelSize: 18
                    color: "grey" //!theme.inverted ? "black" : "white"
                    //height: 20
                    //anchors.verticalCenter: parent.verticalCenter
                }*/
            }

            Slider {
                id:freqSlider
                stepSize:1
                value: updatetimer
                valueIndicatorVisible: true
                minimumValue: 1
                maximumValue: 30
                width: parent.width// - 10
                //anchors.verticalCenter: parent.verticalCenter
                anchors.horizontalCenter: parent.horizontalCenter
            }

        //}

        Row {
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            spacing: 5
            height: 55
            Text {
                text: "Use GPS On Startup"
                width: 315
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                anchors.verticalCenter: parent.verticalCenter
                verticalAlignment: Text.AlignVCenter
            }
            Switch {
                 id: switchGPSUse
                 checked: useGPSOK
                 anchors.verticalCenter: parent.verticalCenter
             }
        }

        Row {
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            spacing: 5
            height: 55
            Text {
                text: "Stop Logs after a 5 minute Pause"
                width: 315
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                anchors.verticalCenter: parent.verticalCenter
                verticalAlignment: Text.AlignVCenter
            }
            Switch {
                 id: switchPause
                 checked: pauseOK
                 anchors.verticalCenter: parent.verticalCenter
             }
        }
        //Disable screensaver
        /*Row {
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            spacing: 5
            height: 55
            Text {
                text: "Keep Screen active?"
                width: 215
                wrapMode: Text.WordWrap
                smooth: true
                font.pixelSize: 22
                color: !theme.inverted ? "black" : "white"
                anchors.verticalCenter: parent.verticalCenter
                verticalAlignment: Text.AlignVCenter
            }
            Switch {
                 id: switchScreenSaver
                 checked: disableScreenSaver
                 anchors.verticalCenter: parent.verticalCenter
             }
        }*/
        // Start New Log Button
        Button {
            id: startlogButton
            anchors.horizontalCenter: parent.horizontalCenter
            text: "Delete all Data"
            width: parent.width - 80
            height: 60
            onClicked: querydeletelogsDialog.open()
        }

        //Spacer - Replace with Horizontal bar
        Rectangle {
            color: "grey"
            height: 1
            width: parent.width - 40
            anchors.horizontalCenter: parent.horizontalCenter
        }

        Text {
            text: "Your Privacy, Location Data/ Location Services."
            font.capitalization: Font.SmallCaps
            font.bold: true
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            wrapMode: Text.WordWrap
            smooth: true
            font.pixelSize: 22
            color: !theme.inverted ? "black" : "white"
        }

        Text {
            text: "We take your Privacy seriously, details are in the About page."
            font.capitalization: Font.SmallCaps
            font.bold: true
            width: parent.width - 20
            anchors.horizontalCenter: parent.horizontalCenter
            wrapMode: Text.WordWrap
            maximumLineCount: 2
            smooth: true
            font.pixelSize: 18
            color: !theme.inverted ? "black" : "white"
        }

    }

    ToolBarLayout {
        id: startTools
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            enabled: true
            onClicked: appWindow.pageStack.pop()
        }
    }

    QueryDialog {
        id: querydeletelogsDialog
        acceptButtonText: "Delete"
        rejectButtonText: "Cancel"
        titleText: "Delete Logs?"
        message: "Do you want to delete all data?\n"
        onAccepted: { Storage.deletealllogs() }
        onRejected: { querydeletelogsDialog.close() }
     }

}
