import QtQuick 1.1
import com.nokia.meego 1.1
import "Storage.js" as Storage

Page {
    tools: splashpageTools
    orientationLock: PageOrientation.LockPortrait
    Component.onCompleted: {
        theme.inverted = true
        Storage.setupsql()
        Storage.currentcounts()
        Storage.cleanfails()
        useGPSOK = Storage.gpsUseGet()
        updatetimer = Storage.freqUpdateGet()
        pauseOK = Storage.pauseGet()
    }

    Image {
        id: splashimage
        source: "Splash.png"
        smooth: true
        anchors.centerIn: parent
        visible: true
        scale: 0.5
    }
    Label {
        id: splashtext
        anchors.top: splashimage.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        text: "GPS LogMee v1.1"
        font.capitalization: Font.SmallCaps
        font.pixelSize: 22
        color: "white"
    }


    ToolBarLayout {
        id: splashpageTools
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: Qt.quit()
        }
    }
}
