function getDatabase() {
     return openDatabaseSync("gpslogmee009", "1.0", "GPS Logger 009", 600000)
}

function setupsql() {
    var db = getDatabase();
    db.transaction(
        //Actual SQL Work
        function(tx) {
                    // Create the database if it doesn't already exist
                    tx.executeSql('CREATE TABLE IF NOT EXISTS LogIndex(indexcount INTEGER PRIMARY KEY, ' +
                                  ' startdate TEXT, starttime TEXT, totaldistance2 REAL, totaltime2 TEXT)');
                    tx.executeSql('CREATE TABLE IF NOT EXISTS LogTable(indexcount INTEGER PRIMARY KEY, ' +
                                  'logindex INTEGER, lat TEXT, lon TEXT, alt TEXT, hspeed TEXT, vspeed TEXT,' +
                                  ' timestamp TEXT, hacc TEXT, vacc TEXT, distance2 REAL)');
                    tx.executeSql('CREATE TABLE IF NOT EXISTS FavTable(indexcount INTEGER PRIMARY KEY, ' +
                                  ' freqtimeFAV INTEGER)');
                    tx.executeSql('CREATE TABLE IF NOT EXISTS mysettings (indexcount INTEGER PRIMARY KEY, ' +
                                  ' freqtimeFAV INTEGER, usegps INTEGER)');
                    var rs = tx.executeSql('SELECT indexcount FROM mysettings LIMIT 1');
                    if(rs.rows.length === 0) {
                        tx.executeSql('INSERT INTO mysettings VALUES(NULL,3,0)');
                    }
                    tx.executeSql('CREATE TABLE IF NOT EXISTS pausesettings (indexcount INTEGER PRIMARY KEY, ' +
                                  ' pauseUse INTEGER)');
                    var rs2 = tx.executeSql('SELECT indexcount FROM pausesettings LIMIT 1');
                    if(rs2.rows.length === 0) {
                        tx.executeSql('INSERT INTO pausesettings VALUES(NULL,0)');
                    }
                }
                )
}

function cleanfails() {

    var db = getDatabase();
    //console.log("heeereee lognumber NULL totaldistance2")
    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex WHERE totaldistance2 = 0');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        //console.log("lognumber NULL totaldistance2 :",currentItem.indexcount)
                        var rsD = tx.executeSql('SELECT SUM(distance2) AS totalD FROM LogTable WHERE logindex = ' + currentItem.indexcount + '');
                        //console.log("rSD TotalDNow:",rsD.rows.item(0).totalD)
                        var rs2 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = '+ currentItem.indexcount +' ');
                        //console.log("howmany? :",rs2.rows.length, "howlong? Guess?:",3*rs2.rows.length)
                        //console.log('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                        //console.log("tx.executeSql('DELETE FROM LogTable where logindex = ",currentItem.indexcount,"');")
                        //console.log("tx.executeSql('DELETE FROM LogIndex where indexcount = ",currentItem.indexcount,"');")
                        tx.executeSql('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                    }
                }
                )

    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex WHERE totaltime2 IS NULL ');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        //console.log("lognumber NULL total time :",currentItem.indexcount)
                        var rsD = tx.executeSql('SELECT SUM(distance2) AS totalD FROM LogTable WHERE logindex = ' + currentItem.indexcount + '');
                        //console.log("rSD TotalDNow:",rsD.rows.item(0).totalD)
                        var rs2 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = '+ currentItem.indexcount +' ');
                        //console.log("howmany? :",rs2.rows.length, "howlong? Guess?:",3*rs2.rows.length)
                        //console.log('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                        //tx.executeSql('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                    }
                }
                )

    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex WHERE totaltime2 = 0 ');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        //console.log("lognumber ZERO total time :",currentItem.indexcount)
                        var rsD = tx.executeSql('SELECT SUM(distance2) AS totalD FROM LogTable WHERE logindex = ' + currentItem.indexcount + '');
                        //console.log("rSD TotalDNow:",rsD.rows.item(0).totalD)
                        var rs2 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = '+ currentItem.indexcount +' ');
                        //console.log("howmany? :",rs2.rows.length, "howlong? Guess?:",3*rs2.rows.length)
                        //console.log('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                        //tx.executeSql('UPDATE LogIndex SET totaldistance2 = "'+ rsD.rows.item(0).totalD +'", totaltime2 = "'+ 3*rs2.rows.length +'" WHERE indexcount = "'+ currentItem.indexcount +'" ');
                    }
                }
                )

    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex WHERE totaltime2 = 0');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        //console.log("tx.executeSql('DELETE FROM LogTable where logindex = ",currentItem.indexcount,"');")
                        //console.log("tx.executeSql('DELETE FROM LogIndex where indexcount = ",currentItem.indexcount,"');")
                        tx.executeSql('DELETE FROM LogTable where logindex = '+currentItem.indexcount+'');
                        tx.executeSql('DELETE FROM LogIndex where indexcount = '+currentItem.indexcount+'');
                    }
                }
                )

    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex WHERE totaldistance2 = 0');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        //console.log("tx.executeSql('DELETE FROM LogTable where logindex = ",currentItem.indexcount,"');")
                        //console.log("tx.executeSql('DELETE FROM LogIndex where indexcount = ",currentItem.indexcount,"');")
                        tx.executeSql('DELETE FROM LogTable where logindex = '+currentItem.indexcount+'');
                        tx.executeSql('DELETE FROM LogIndex where indexcount = '+currentItem.indexcount+'');
                    }
                }
                )

}

/**
 * Check if GPS is OK Automatic
 */
function gpsUseGet () {
    var useGPS
    useGPS = false
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs3 = tx.executeSql('SELECT usegps FROM mysettings');
                    if(rs3.rows.item(0).usegps == 1) { useGPS = true; }
                    //console.log("USE GPS?",rs3.rows.item(0).usegps, useGPS)
                })
    return useGPS
}

/**
 * Change USE GPS
 */
function gpsUseChange (newstate) {
    var gpsUSEState
    if(newstate === true) {gpsUSEState = 1;}
    else {gpsUSEState = 0;}
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs = tx.executeSql('UPDATE mysettings SET usegps = "'+ gpsUSEState +'" WHERE indexcount = 1');
                    //console.log("GPS USE State setting, Rows changed: ",rs.rowsAffected,newstate,gpsUSEState)
                })
}

/**
 * Check if Pause is OK Automatic
 */
function pauseGet () {
    var pauseUse
    pauseUse = false
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs3 = tx.executeSql('SELECT pauseUse FROM pausesettings');
                    if(rs3.rows.item(0).pauseUse == 1) { pauseUse = true; }
                    console.log("USE pauseGet?",rs3.rows.item(0).pauseUse, pauseUse)
                })
    return pauseUse
}

/**
 * Change Pause
 */
function pauseChange (newstate) {
    var pauseState
    if(newstate === true) {pauseState = 1;}
    else {pauseState = 0;}
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs = tx.executeSql('UPDATE pausesettings SET pauseUse = "'+ pauseState +'" WHERE indexcount = 1');
                    console.log("Pause State setting, Rows changed: ",rs.rowsAffected," new state = ",newstate,pauseState)
                })
}

/**
 * Check update Frequence
 */
function freqUpdateGet () {
    var usefreqtimeFAV
    usefreqtimeFAV = "12"
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs3 = tx.executeSql('SELECT * FROM mysettings');
                    usefreqtimeFAV = rs3.rows.item(0).freqtimeFAV
                    //console.log("Startpage:",useIntroPage,rs3.rows.item(0).indexcount)
                })
    return usefreqtimeFAV
}

/**
 * Change update Frequence
 */
function freqUpdateChange (newfreq) {
    var freqUpdateUSE
    freqUpdateUSE = newfreq;
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs = tx.executeSql('UPDATE mysettings SET freqtimeFAV = "'+ freqUpdateUSE +'" WHERE indexcount = 1');
                    //console.log("here new freqtimeFAV setting, rows changed: ",rs.rowsAffected,newfreq,freqUpdateUSE)
                })
}

function addfav (favvalue) {
    var db = getDatabase();
    var vfavAvalue = favvalue
    db.transaction(
        function(tx) {
                    var rs = tx.executeSql('INSERT INTO FavTable VALUES(NULL,\''+ vfavAvalue +'\')');
                }
                )
}

function getfavs() {
    var db = getDatabase();
    db.transaction(
        function(tx) {
                    var rs3 = tx.executeSql('SELECT * FROM FavTable ORDER BY indexcount LIMIT 1');
                    for(var i = 0; i < rs3.rows.length; i++) {
                        var currentItem = rs3.rows.item(i)
                        freqtimeFAV = currentItem.freqtimeFAV
                    }
                    if(rs3.rows.length === 0) {
                        freqtimeFAV = 3
                    }
                }
                )
}

function oldlogstoview() {
    //logsmodel.clear()
    var db = getDatabase();
    var res = [];
    db.transaction(
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogIndex');
                    for(var i = 0; i < rs.rows.length; i++) {
                        var currentItem = rs.rows.item(i)
                        res.push({'lognumber': currentItem.indexcount,
                                     'logstartdate': currentItem.startdate,
                                     'logstarttime': currentItem.starttime,
                                     'logtotaldistance': currentItem.totaldistance2,
                                     'logruntime': currentItem.totaltime2})
                    }
                    /*logsmodel.append({"lognumber":rs.rows.item(i).indexcount, "logstartdate":rs.rows.item(i).startdate
                    , "logstarttime":rs.rows.item(i).starttime
                    , "logtotaldistance":rs.rows.item(i).totaldistance2
                    , "logruntime":rs.rows.item(i).totaltime2})
                    }

                    for(var i = 0; i < rs.rows.length; i++) {
                        //console.log("lognumber: ",logsmodel.get(i).lognumber)
                        //console.log("logstartdate: ",logsmodel.get(i).logstartdate)
                        //console.log("logtotaldistance: ",logsmodel.get(i).logtotaldistance)
                    }
                    //var rs2 = tx.executeSql('SELECT * FROM LogIndex WHERE indexcount = "'+ currentlogindex +'" ');
                    //console.log("count: ",logsmodel.count)*/
                }
                )
    return res
}

function detailedogstoview(lognumberV) {
    //coords1 = "";
    //coords2 = "";
    //detailedviewmodel.clear()
    //console.log("Count of detailedviewmodel:  ",detailedviewmodel.count)
    var lognumbernow = lognumberV
    var db = getDatabase();
    var res = [];
    //trackingurl = "";
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernow + ' ');
                    var skipentry = 0;
                    var howmany = rs.rows.length;
                    if(howmany < 25 ) { skipentry = 1  }
                    else if(howmany <= 50 ) { skipentry = 2  }
                    else if(howmany <= 100 ) { skipentry = 4  }
                    else if(howmany <= 500 ) { skipentry = 20  }
                    else if(howmany <= 1000 ) { skipentry = 40  }
                    else if(howmany <= 2000 ) { skipentry = 80  }
                    else if(howmany > 2000 ) { skipentry = 100  }
                    //console.log ("Getting detailed logs now, we have ",howmany," and we are going to skip ",skipentry)
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        var currentItem = rs.rows.item(i)
                        //if(trackingurl== "") {trackingurl = rs.rows.item(i).lat + "," + rs.rows.item(i).lon}
                        //else {
                        //trackingurl = rs.rows.item(i).lat + "," + rs.rows.item(i).lon + "," + trackingurl
                        //}
                        res.push({'entrynumber': i+1,
                                     'mainlognumber':currentItem.logindex,
                                     'lat':currentItem.lat,
                                     'lon':currentItem.lon,
                                     'alt':currentItem.alt,
                                     "hspeed":rs.rows.item(0).hspeed,
                                     "tstamp":rs.rows.item(0).timestamp,
                                     'distance2':currentItem.distance2});
                        //if(coords1 == "") {
                        //    coords1 = currentItem.lat + "," + currentItem.lon
                        //    coords2 = currentItem.lat + "," + currentItem.lon
                        //}
                        //else {
                        //    coords1 = coords1 + "#" + currentItem.lat + "," + currentItem.lon
                        //}
                    }
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernow + ' ORDER BY indexcount DESC LIMIT 1');
                    res.push({"entrynumber": "End",
                                 "mainlognumber":rs.rows.item(0).logindex,
                                 "lat":rs.rows.item(0).lat,
                                 "lon":rs.rows.item(0).lon,
                                 "alt":rs.rows.item(0).alt,
                                 "hspeed":rs.rows.item(0).hspeed,
                                 "tstamp":rs.rows.item(0).timestamp,
                                 "distance2":rs.rows.item(0).distance2});
                }
                )
    return res
}

function detailedogstoviewD(lognumberV) {
    var db = getDatabase();
    var lognumbernowD = lognumberV
    var res;
    //console.log("Here in distance JS")
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    //tx.executeSql('UPDATE LogIndex SET totaldistance2 = "'+ totald +'", totaltime2 = "'+ logruntimenow +'" WHERE indexcount = "'+ currentlogindex +'" ');
                    var rs2 = tx.executeSql('SELECT totaldistance2 FROM LogIndex WHERE indexcount = "'+ lognumbernowD +'" LIMIT 1');
                    //for(var i = 0; i < rs2.rows.length; i = i++) {
                        res = rs2.rows.item(0).totaldistance2
                        //console.log("total distance",res)
                    //}
                    //var rs = tx.executeSql('SELECT indexcount FROM LogIndex');
                    //lognumbernowD = rs2.rows.length;
                    //countlogindexes = logentries;
                }
                )
    //gpslogtime = 0;
    return res
}

function detailedogstoviewS(lognumberV) {
    var db = getDatabase();
    var lognumbernowS = lognumberV
    var res;
    //console.log("Here in distance JS")
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = '+ lognumbernowS +' ');
                    //for(var i = 0; i < rs2.rows.length; i = i++) {
                        res = rs2.rows.length
                        //console.log("total samples",res)
                }
                )
    //gpslogtime = 0;
    return res
}

function detailedogstoviewSpeed(lognumberV) {
    var db = getDatabase();
    var lognumbernowSp = lognumberV
    var res;
    //console.log("Here in distance JS")
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT MAX(hspeed) AS mspeed FROM LogTable WHERE logindex = '+ lognumbernowSp +' ');
                    //for(var i = 0; i < rs2.rows.length; i = i++) {
                        res = rs2.rows.item(0).mspeed
                        //console.log("max speed",res)
                }
                )
    //gpslogtime = 0;
    return res
}

function NotUSEDonlinelogstoview(lognumberV) {
    var lognumbernowO = lognumberV
    coords1 = "";
    coords2 = "";
    data1 = "";
    var db = getDatabase();
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs3 = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    var skipentry = 0;
                    var howmany = rs3.rows.length;
                    if(howmany < 25 ) { skipentry = 0  }
                    else if(howmany <= 50 ) { skipentry = 0  }
                    else if(howmany <= 100 ) { skipentry = 1  }
                    else if(howmany <= 500 ) { skipentry = 2  }
                    else if(howmany <= 1000 ) { skipentry = 2  }
                    else if(howmany <= 2000 ) { skipentry = 2  }
                    else if(howmany <= 4000 ) { skipentry = 5  }
                    else if(howmany > 4000 ) { skipentry = 10  }
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        if(coords1 == "") {
                            coords1 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                            coords2 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                        }
                        else {
                            coords1 = coords1 + "#" + rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                        }
                    }
                }
                )
}

function newlog(startdate,starttime) {
    var startdatenow = startdate
    var starttimenow = starttime
    var db = getDatabase();
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex');
                    logentries = rs.rows.length;
                    tx.executeSql('INSERT INTO LogIndex (startdate, starttime) VALUES (\''+ startdatenow +'\',\''+ starttimenow +'\')');
                    var rs2 = tx.executeSql('SELECT MAX(indexcount) AS rid FROM LogIndex');
                    currentlogindex = rs2.rows.item(0).rid
                }
                )
    //console.log("SQL - New Log",logentries,currentlogindex)

}

function newentry(index,lat,lon,speedh,d,alth,timest) {
    var indexnow = index
    var latnow = lat
    var lonnow = lon
    var altnow = alth
    var speednow = speedh
    var timenow = timest
    var dnow = d
    var db = getDatabase();
    var notHD = 0;
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    tx.executeSql('INSERT INTO LogTable VALUES (NULL,' +
                                  '\'' + indexnow + '\',' +
                                  '\'' + latnow + '\',' +
                                  '\'' + lonnow + '\',' +
                                  '\'' + altnow + '\',' +
                                  '\''+ speednow +'\',' +
                                  '\'0\',' +
                                  '\''+ timenow +'\',' +
                                  '\'0\',' +
                                  '\'0\',' +
                                  '\'' + d + '\')');
                    var rs = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = ' + indexnow + '');
                    detailedentries = rs.rows.length;
                    var rs2 = tx.executeSql('SELECT TOTAL(distance2) AS totald FROM LogTable WHERE logindex = ' + indexnow + '');
                    totald = rs2.rows.item(0).totald
                }
                )
}

function newentryHD() {
    var db = getDatabase();
    db.transaction(
                //Actual SQL Work
                function(tx) {
                        tx.executeSql('INSERT INTO LogTable VALUES (NULL,' +
                                      '\'' + currentlogindex + '\',' +
                                      '\'' + positionSource.position.coordinate.latitude + '\',' +
                                      '\'' + positionSource.position.coordinate.longitude + '\',' +
                                      '\'' + positionSource.position.coordinate.altitude + '\',' +
                                      '\'' + positionSource.position.speed + '\',' +
                                      '\'' + positionSource.position.speed + '\',' +
                                      '\'' + positionSource.position.timestamp + '\',' +
                                      '\'' + positionSource.position.horizontalAccuracy + '\',' +
                                      '\'' + positionSource.position.verticalAccuracy + '\',' +
                                      '\'' + d + '\')');

                    var rs = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = ' + currentlogindex + '');
                    detailedentries = rs.rows.length;
                    var rs2 = tx.executeSql('SELECT TOTAL(distance2) AS totald FROM LogTable WHERE logindex = ' + currentlogindex + '');
                    totald = rs2.rows.item(0).totald
                    //console.log("In the JS?");
                }
                )


}

function stoplog(logruntime) {
    var db = getDatabase();
    var logruntimenow = logruntime
    //console.log("RunTimes",logruntimenow,logruntime)
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    tx.executeSql('UPDATE LogIndex SET totaldistance2 = "'+ totald +'", totaltime2 = "'+ logruntimenow +'" WHERE indexcount = "'+ currentlogindex +'" ');
                    var rs2 = tx.executeSql('SELECT * FROM LogIndex WHERE indexcount = "'+ currentlogindex +'" ');
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex');
                    logentries = rs.rows.length;
                    countlogindexes = logentries;
                }
                )
    //gpslogtime = 0;
}

function currentcounts() {
    var db = getDatabase();
    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex');
                    countlogindexes = rs.rows.length;
                    var rs2 = tx.executeSql('SELECT indexcount FROM LogTable');
                    countlogentries = rs.rows.length;
                }
                )
}

function livetracking(){
    var db = getDatabase();
    livetrackingurl = "";
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + currentlogindex + ' ');
                    var skipentry = 0;
                    var howmany = rs.rows.length;
                    if(howmany < 25 ) { skipentry = 1  }
                    else if(howmany <= 50 ) { skipentry = 2  }
                    else if(howmany <= 100 ) { skipentry = 4  }
                    else if(howmany <= 500 ) { skipentry = 20  }
                    else if(howmany <= 1000 ) { skipentry = 40  }
                    else if(howmany <= 2000 ) { skipentry = 80  }
                    else if(howmany > 2000 ) { skipentry = 100  }
                    //console.log (howmany, skipentry)
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {

                        if(livetrackingurl== "") {livetrackingurl = rs.rows.item(i).lat + "," + rs.rows.item(i).lon}
                        else {
                        livetrackingurl = rs.rows.item(i).lat + "," + rs.rows.item(i).lon + "," + livetrackingurl
                        }

                    }

                }
                )
    livetrackingurl = positionSource.position.coordinate.latitude + "," + positionSource.position.coordinate.longitude + "," + livetrackingurl
}

function livetrackingCoOrd(moredetail){
    var returnmoredetails = moredetail;
    var db = getDatabase();
    var res = [];
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + currentlogindex + ' ');
                    var skipentry = 0;
                    var howmany = rs.rows.length;
                    if(howmany < 25 ) { skipentry = 1  }
                    else if(howmany <= 50 ) { skipentry = 2  }
                    else if(howmany <= 100 ) { skipentry = 4  }
                    else if(howmany <= 500 ) { skipentry = 10  }
                    else if(howmany <= 1000 ) { skipentry = 20  }
                    else if(howmany <= 2000 ) { skipentry = 30  }
                    else if(howmany > 2000 ) { skipentry = 50  }
                    if (returnmoredetails == 1 && skipentry > 1) { skipentry = skipentry /2; //console.log("Skip half as many")
                    }
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        var currentItem = rs.rows.item(i)
                        res.push({'lvtklat': currentItem.lat,
                                     'lvtklon':currentItem.lon});
                        }
                    }
                )
    return res
}

function oldMaptrackingCoOrd(moredetail,logindex){
    var returnmoredetails = moredetail;
    var logindexnow = logindex
    var db = getDatabase();
    var res = [];
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + logindexnow + ' ');
                    var skipentry = 0;
                    var howmany = rs.rows.length;
                    if(howmany < 25 ) { skipentry = 1  }
                    else if(howmany <= 50 ) { skipentry = 2  }
                    else if(howmany <= 100 ) { skipentry = 4  }
                    else if(howmany <= 500 ) { skipentry = 10  }
                    else if(howmany <= 1000 ) { skipentry = 20  }
                    else if(howmany <= 2000 ) { skipentry = 30  }
                    else if(howmany > 2000 ) { skipentry = 50  }
                    if (returnmoredetails == 1 && skipentry > 1) { skipentry = skipentry /2; console.log("Skip half as many")}
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        var currentItem = rs.rows.item(i)
                        res.push({'lvtklat': currentItem.lat,
                                     'lvtklon':currentItem.lon});
                        }
                    }
                )
    return res
}

function trackingCoOrd(lognumberV){
    var db = getDatabase();
    var longnumberNow = lognumberV
    var res = [];
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + longnumberNow + ' ');
                    var skipentry = 0;
                    var howmany = rs.rows.length;
                    if(howmany < 25 ) { skipentry = 1  }
                    else if(howmany <= 50 ) { skipentry = 1  }
                    else if(howmany <= 100 ) { skipentry = 2  }
                    else if(howmany <= 500 ) { skipentry = 10  }
                    else if(howmany <= 1000 ) { skipentry = 20  }
                    else if(howmany <= 2000 ) { skipentry = 30  }
                    else if(howmany > 2000 ) { skipentry = 40  }
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        var currentItem = rs.rows.item(i)
                        res.push({'lvtklat': currentItem.lat,
                                     'lvtklon':currentItem.lon});
                        }
                    }
                )
    return res
}

function onlinelogstoview(lognumberV) {
    var lognumbernowO = lognumberV
    coords1 = "";
    coords2 = "";
    data1 = "";
    data2 = "";
    data3 = "";
    var db = getDatabase();
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs3 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    var skipentry = 0;
                    var howmany = rs3.rows.length;
                    //console.log ("here to count, this many > ",howmany)
                    if(howmany < 500 ) { skipentry = 1  }
                    else if(howmany <= 1000 ) { skipentry = 2  }
                    else if(howmany <= 4000 ) { skipentry = 5  }
                    else if(howmany > 4000 ) { skipentry = 10  }
                    //console.log ("here to skip, this many > ",skipentry)
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        //console.log("Internal Loop for final selection. Step no. ",i," out of ",rs.rows.length)
                        if(coords1 == "") {
                            coords1 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                            coords2 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                        }
                        else {
                            coords1 = coords1 + "#" + rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                        }
                    }
                }
                )

    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT MAX(hspeed) AS mspeed FROM LogTable WHERE logindex = '+ lognumbernowO +' ');
                        data2 = rs2.rows.item(0).mspeed
                }
                )
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT totaldistance2 FROM LogIndex WHERE indexcount = "'+ lognumbernowO +'" LIMIT 1');
                        data3 = rs2.rows.item(0).totaldistance2
                }
                )
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT totaltime2 FROM LogIndex WHERE indexcount = "'+ lognumbernowO +'" LIMIT 1');
                        data1 = rs2.rows.item(0).totaltime2
                }
                )
}

function logstosave(lognumberV) {
    var lognumbernowO = lognumberV
    coords1 = "";
    coords2 = "";
    data1 = "";
    data2 = "";
    data3 = "";
    var db = getDatabase();
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs3 = tx.executeSql('SELECT indexcount FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    var skipentry = 0;
                    var howmany = rs3.rows.length;
                    //console.log ("here to count, this many > ",howmany)
                    if(howmany < 500 ) { skipentry = 1  }
                    else if(howmany <= 1000 ) { skipentry = 2  }
                    else if(howmany <= 4000 ) { skipentry = 5  }
                    else if(howmany > 4000 ) { skipentry = 10  }
                    //console.log ("here to skip, this many > ",skipentry)
                    var rs = tx.executeSql('SELECT * FROM LogTable WHERE logindex = ' + lognumbernowO + ' ');
                    for(var i = 0; i < rs.rows.length; i = i+skipentry) {
                        //console.log("Internal Loop for final selection. Step no. ",i," out of ",rs.rows.length)
                        if(coords1 == "") {
                            coords1 = '<gpx creator="GPS LogMee" version="1.x">\n' +
                                '   <wpt lat="'+ rs.rows.item(i).lat +'" lon="'+ rs.rows.item(i).lon +'"><ele>'+rs.rows.item(i).alt+'</ele><name>Start Point</name><sym>Trail Head</sym></wpt>\n' +
                                '   <trk>\n'+
                                '   <name>GPS LogMee Track</name>\n'+
                                '       <trkseg>\n'

                            //coords1 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                            //coords2 = rs.rows.item(i).lat + "," + rs.rows.item(i).lon
                        }
                        else {
                            coords1 += '         <trkpt lat="'+ rs.rows.item(i).lat +'" lon="'+ rs.rows.item(i).lon +'">\n'+
                                    '           <time>'+ rs.rows.item(i).timestamp +'</time>\n'+
                                    '           <ele>'+rs.rows.item(i).alt+'</ele>\n'+
                                    '         </trkpt>\n'
                        }
                    }
                    coords1 += '       </trkseg>\n'+
                        '   </trk>\n'+
                        '</gpx>'
                }
                )

    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT MAX(hspeed) AS mspeed FROM LogTable WHERE logindex = '+ lognumbernowO +' ');
                        data2 = rs2.rows.item(0).mspeed
                }
                )
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT totaldistance2 FROM LogIndex WHERE indexcount = "'+ lognumbernowO +'" LIMIT 1');
                        data3 = rs2.rows.item(0).totaldistance2
                }
                )
    db.transaction(
                //Actual SQL Work
                function(tx) {
                    var rs2 = tx.executeSql('SELECT totaltime2 FROM LogIndex WHERE indexcount = "'+ lognumbernowO +'" LIMIT 1');
                        data1 = rs2.rows.item(0).totaltime2
                }
                )
}

function findrealdistance() {
    var earthr = 6371; // km
    var dlat = (oldlat-positionSource.position.coordinate.latitude) * Math.PI / 180;
    var dlon = (oldlon-positionSource.position.coordinate.longitude) * Math.PI / 180;
    var a = Math.sin(dlat/2) * Math.sin(dlat/2) + Math.cos(positionSource.position.coordinate.latitude * Math.PI / 180) * Math.cos(avglat * Math.PI / 180) * Math.sin(dlon/2) * Math.sin(dlon/2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
    d = Math.round(earthr * c * 1000);
    //console.log ("here is the distance",d)
    oldlat = positionSource.position.coordinate.latitude
    oldlon = positionSource.position.coordinate.longitude
    return d;
}

function deletethislog(lognumberV) {
    var db = getDatabase();
    var deletelognumbernow = lognumberV

    db.transaction(
        //Actual SQL Work
        function(tx) {
            // Delete the table contents for StationsLines
            tx.executeSql('DELETE FROM LogTable where logindex = ' + deletelognumbernow + '');
            //var rs = tx.executeSql('SELECT * FROM LogTable');
                //{
                    //console.log("delete done. ", rs.rows.length)
                //}
            tx.executeSql('DELETE FROM LogIndex where indexcount = ' + deletelognumbernow + '');
            //var rs = tx.executeSql('SELECT * FROM LogIndex');
                //{
                    //console.log("delete done LogIndex. ", rs.rows.length)
                //}
        }
    )
    db.transaction(
        //Actual SQL Work
                function(tx) {
                    var rs = tx.executeSql('SELECT indexcount FROM LogIndex');
                    countlogindexes = rs.rows.length;
                    var rs2 = tx.executeSql('SELECT indexcount FROM LogTable');
                    countlogentries = rs.rows.length;
                }
                )
}

function deletealllogs() {
    var db = getDatabase();
    db.transaction(
        //Actual SQL Work
        function(tx) {
            // Delete the table contents for StationsLines
            tx.executeSql('DELETE FROM LogTable');
            var rs = tx.executeSql('SELECT * FROM LogTable');
                {
                    //console.log("delete done. ", rs.rows.length)
                }
            tx.executeSql('DELETE FROM LogIndex');
            var rs = tx.executeSql('SELECT * FROM LogIndex');
                {
                    //console.log("delete done LogIndex. ", rs.rows.length)
                }
        }
    )
    countlogindexes = 0;
    countlogentries = 0;
}
